----------------------------------------------------------------------------------
-- PS2 controller test bench 
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;


entity PS2_controller_tb is
--  Port ( );
end PS2_controller_tb;

architecture Behavioral of PS2_controller_tb is
    constant clock_period : time := 10 ns;
    constant PS2_CLK_period : time := 2*3.14 * clock_period;
     
    -- Simuliramo posiljanje kode za tipko ENTER: 0x5A = 0101 1010
    -- STOP PAR B7 ... B1 B0 START
    --  1    1  0  ... 1  0    0
    constant data_sim : std_logic_vector(10 downto 0) := "11010110100";
    signal CLK100MHZ : std_logic := '1';
    signal CPU_RESETN, PS2_CLK, PS2_DATA, eot : std_logic;
    signal data : std_logic_vector(8 downto 0);
    
begin

    UUT: entity work.PS2_controller(Behavioral)
    port map(
        CLK100MHZ => CLK100MHZ,
        CPU_RESETN => CPU_RESETN,
        PS2_CLK => PS2_CLK,
        PS2_DATA => PS2_DATA,
        data => data,
        eot => eot
    );

    stimulus_clk: process 
    begin 
        CLK100MHZ <= not CLK100MHZ;
        wait for clock_period/2;
    end process;

    stimuli_oth: process 
    begin 
        
        -- dolgi reset 
        CPU_RESETN <= '0'; -- obratna logika
        PS2_CLK   <= '1'; -- mirovanje 
        PS2_DATA <= '1';
        wait for clock_period*3; 
        
        -- sprostimo reset, mirujemo 
        CPU_RESETN <= '1'; -- obratna logika
        PS2_CLK   <= '1'; -- mirovanje 
        PS2_DATA <= '1';
        wait for clock_period*3;
        
        -- zamaknemo as, da nismo sinhroni z notranjo uro 
        wait for clock_period*0.3334;
        
        for i in 0 to 10 loop
            PS2_DATA <= data_sim(i);
            wait for PS2_CLK_period/8;
            PS2_CLK <= '0';
            wait for PS2_CLK_period/2;
            PS2_CLK <= '1';
            wait for PS2_CLK_period/2;
        end loop;
        
        -- Mirovanje v neskoncnost 
        wait;
    
    end process;


end Behavioral;
