----------------------------------------------------------------------------------
-- Test bench for pulse generator 
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;


entity PS2_pulse_gen_tb is
--  Port ( );
end PS2_pulse_gen_tb;

architecture Behavioral of PS2_pulse_gen_tb is

    constant clock_period : time := 10 ns;
    signal clock, reset, PS2_CLK_S, pulse : std_logic;
    
begin
    UUT: entity work.PS2_pulse_gen(Behavioral)
    port map(
        clock => clock,
        reset => reset, 
        PS2_CLK_S => PS2_CLK_S,
        pulse => pulse
    );
    
    -- Drazljaji 
    stimuli_clk: process 
    begin 
        clock <= '0';
        wait for clock_period/2;
        clock <= '1';
        wait for clock_period/2;
    end process;
    
    stimuli_other: process 
    begin
        -- Dolgi reset 
        reset <= '1';
        PS2_CLK_S <= '1';
        wait for clock_period*4;
        
        -- Sprostimo reset 
        reset <= '0';
        wait for clock_period*4;
        
        -- Tvorimo periodicni signal PS2_CLK_S
        for i in 1 to 3 loop 
            PS2_CLK_S <= '0';
            wait for clock_period*7;
            PS2_CLK_S <= '1';
            wait for clock_period*7;
        end loop;
        
        -- Cakaj v neskoncnost 
        wait; 
        
    end process;
    

end Behavioral;
